<?php
/*

Nucleus plugin by Armon Toubman
created September 4, 2007

based on wordpress plugin by
Priyadi Iman Nurcahyo
http://priyadi.net/archives/2005/02/25/wordpress-ip-to-country-plugin/

"This script uses the IP-to-Country Database
 provided by WebHosting.Info (http://www.webhosting.info),
 available from http://ip-to-country.webhosting.info."

"In addition, mod_geoip support is added in v0.3. Note 3 code country code is not available in mod_geoip"
 
flags from http://planetozh.com/blog/2005/09/flag-icons/

todo:
- ip database download, update mechanism
*/

class NP_IP2Country extends NucleusPlugin {
	
	var $countryTable = "plug_ip2country_countries";
	var $commentTable = "plug_ip2country_comments";

	function getEventList() { return array('PostAddComment', 'PreDeleteComment'); }
	function getName() { return 'IP2Country'; }
	function getAuthor() { return 'Armon Toubman based on WP plugin by Priyadi Iman Nurcahyo, mod by admun (Edmond Hui)'; }
	function getURL() { return ''; }
	function getVersion() { return '0.3'; }
	function getDescription() {
		return 'Track IP address of visitor and commentor';
	}
	function supportsFeature($feature) {
		switch($feature) {
			case 'SqlTablePrefix': return 1;
			default: return 0;
		}
	}
	function getTableList() {
		return array(sql_table($countryTable), sql_table($commentTable));
	}
	function install() {
		global $DIR_PLUGINS;
		$sql = "CREATE TABLE IF NOT EXISTS `".sql_table($this->commentTable)."` (
					`commentid` int(11) NOT NULL default '0',
					  `country_code2` char(2) default NULL,
					  `country_code3` char(3) default NULL,
					  `country_name` varchar(50) default NULL
				)";
		sql_query($sql);
		$sql = "CREATE TABLE `".sql_table($this->countryTable)."` (`ip_from` int(4) unsigned default NULL,`ip_to` int(4) unsigned default NULL,`country_code2` char(2) default NULL,`country_code3` char(3) default NULL,`country_name` varchar(50) default NULL) TYPE=MyISAM";
		sql_query($sql);

		/* http authorization blabla
		$sqlFile = file_get_contents($this->getAdminURL()."iptocountry.sql");
		sql_query($sqlFile);*/

		$url = $DIR_PLUGINS."/ip2country/iptocountry.sql";
		 $file_content = file($url);
		 foreach($file_content as $sql_line){
			if(trim($sql_line) != "" && strpos($sql_line, "--") === false){
				//echo $sql_line . '<br>';

				sql_query($sql_line);
			}
	   	}
		$this->createOption('removedb', 'Remove IP-to-Country table on uninstall?', 'yesno', 'yes');
	}

	function uninstall() {
		$sql = "DROP TABLE `".sql_table($this->commentTable)."`";
		sql_query($sql);
		if($this->getOption('removedb') == 'yes') {
			$sql = "DROP TABLE `".sql_table($this->countryTable)."`";
			sql_query($sql);
		}
	}
	
	function doSkinVar($skintype,$what = '') {
		$ip = $_SERVER['REMOTE_ADDR'];
		if ($_SERVER['GEOIP_COUNTRY_CODE'] != '') {
			$obj->country_name = $_SERVER['GEOIP_COUNTRY_NAME'];
			$obj->country_code2 = $_SERVER['GEOIP_COUNTRY_CODE'];
			$obj->country_code3 = '';
		} else {
			$obj = $this->wp_ip2c_getdb_fromdb($ip);
		}

		switch ($what) {
			case 'name':
				echo $obj->country_name;
				break;
			case 'code2':
				echo $obj->country_code2;
				break;
			case 'code3':
				echo $obj->country_code3;
				break;
			case 'flag':
			default:
				$image_url = $this->getAdminURL() . "flag_" . strtolower($obj->country_code2) . ".gif";
				$image_file = $this->getDirectory() . "flag_" . strtolower($obj->country_code2) . ".gif";
				if (file_exists($image_file)) {
					echo "<img src=\"" . $image_url . "\" alt=\"".$array['country_name']."\" />";
				}
				break;
		}
	}
	
	function event_PostAddComment(&$data) {
		$id = $data['commentid'];
		$ip = $_SERVER['REMOTE_ADDR'];
		if ($_SERVER['GEOIP_COUNTRY_CODE'] != '') {
			$obj->country_name = $_SERVER['GEOIP_COUNTRY_NAME'];
			$obj->country_code2 = $_SERVER['GEOIP_COUNTRY_CODE'];
			$obj->country_code3 = '';
		} else {
			$obj = $this->wp_ip2c_getdb_fromdb($ip);
		}

		$cc2 = $obj->country_code2;
		$cc3 = $obj->country_code3;
		$cn = $obj->country_name;
		//if ($cc2 == '' || $cc3 == '' || $cn == '') return;

		$sql = "INSERT INTO ".sql_table($this->commentTable)." (commentid, country_code2, country_code3, country_name) VALUES (".$id.", '".$cc2."', '".$cc3."', '".$cn."')";
		sql_query($sql);
	}
	
	function event_PreDeleteComment($data) {
		$id = $data['commentid'];
		$sql = "DELETE FROM ".sql_table($this->commentTable)." WHERE commentid=".$id;
		sql_query($sql);
	}
	
	function doTemplateCommentsVar(&$item, &$comment, $what = '') {
		$id = $comment['commentid'];
		$array = $this->getCommentCountry($id);
		if(!empty($array)) {
			if($what == 'name') {
				echo $array['country_name'];
			}
			if($what == 'code2') {
				echo $array['country_code2'];
			}
			if($what == 'code3') {
				echo $array['country_code3'];
			}
			if($what == 'flag') {
				$image_url = $this->getAdminURL() . "flag_" 
				           . strtolower($array['country_code2']) . ".gif";
				$image_file = $this->getDirectory() . "flag_" 
				            . strtolower($array['country_code2']) . ".gif";
				if (file_exists($image_file)) {
					echo "<img src=\"" . $image_url . "\" alt=\"".$array['country_name']."\" />";
				}
			}
		}
	}
	
	function getCommentCountry($id) {
		$sql = "SELECT * FROM ".sql_table($this->commentTable)." WHERE commentid = ".$id;
		$result = sql_query($sql);
		$array = mysql_fetch_assoc($result);
		return $array;
	}
	
	function wp_ip2c_getdb_fromdb ($ip) {
		$sql = "SELECT * FROM " . sql_table($this->countryTable) 
		     . " WHERE inet_aton('$ip') BETWEEN ip_from AND ip_to";
		$row = sql_query($sql);
		$object = mysql_fetch_object($row);
		return $object;
	}
}
?>
